diff --git a/net/packet/af_packet.c b/net/packet/af_packet.c
index 13666fe787db..109a848aca15 100644
--- a/net/packet/af_packet.c
+++ b/net/packet/af_packet.c
@@ -1975,7 +1975,7 @@ static int packet_sendmsg_spkt(struct socket *sock, struct msghdr *msg,
 		goto retry;
 	}
 
-	if (!dev_validate_header(dev, skb->data, len)) {
+	if (!dev_validate_header(dev, skb->data, len) || !skb->len) {
 		err = -EINVAL;
 		goto out_unlock;
 	}
